# encoding: utf-8
# frozen_string_literal: true

module Carbon
  module Concrete
    module Item
      # A data definition.  All data definitions include this module, which
      # acts as a sort of hirearchy.  It makes it easy to identify if an item
      # is a data definition or a function definition.
      module Data
        include Base

        # The traits that the data type implements.  This is mostly used for
        # validation and logic.
        #
        # @api public
        # @return [<Type>]
        attr_reader :implements
      end
    end
  end
end
