# encoding: utf-8
# frozen_string_literal: true

module Carbon
  module Core
    module Pointer
      # Defines the pointer type.
      module Type
        # Defines the pointer type, setting it to implement both
        # `Carbon::Sized` and `Carbon::Numeric`.
        #
        # @return [void]
        def define_pointer_type
          Core.define(internal: PTYPE) do |internal|
            internal[:kind] = :pointer
            internal[:implements] << Carbon::Type("Carbon::Sized")
            internal[:implements] << Carbon::Type("Carbon::Numeric")
          end
        end
      end
    end
  end
end
