# encoding: utf-8
# frozen_string_literal: true

require "carbon/tacky/block"
require "carbon/tacky/builder"
require "carbon/tacky/context"
require "carbon/tacky/function"
require "carbon/tacky/value"
require "carbon/tacky/instruction"
require "carbon/tacky/parameter"
require "carbon/tacky/reference"
require "carbon/tacky/typed"

module Carbon
  # Tacky is a IR implementation.  It is a medium-level IR, just above LLVM IR
  # and just below Carbon.  It is here in order to easily serialize the
  # results of compiling a Carbon file without loosing generic information,
  # which is essential for building everything else.  Tacky is meant to be
  # easily serialized and deserialized, to allow libraries to be created.
  module Tacky
  end
end
