# encoding: utf-8
# frozen_string_literal: true

module Carbon
  module Tacky
    # A parameter that's been passed in by a function.  This just contains the
    # number, name, and type of the parameter, for proper mapping later.
    class Parameter < Value
      # Initializes the parameter with the given number, name, and type.
      #
      # @param number [::Numeric] The number of the parameter.  The far left
      #   of a parameter list is zero (0).
      # @param type [Concrete::Type] The type of the parameter.
      # @param name [::String] The name of the parameter.  If one is not given,
      #   the name is autogenerated.
      def initialize(number, type, name = "")
        @name = name
        @type = type
        @value = number
      end
    end
  end
end
