# encoding: utf-8
# frozen_string_literal: true

module Carbon
  module Tacky
    # A "reference."  A reference is essentially a mapping to an instruction
    # that returned a value, and the reference takes the place of said value.
    # The reference represents the return value of an instruction.
    class Reference
      # The id of the instruction that this reference points to.
      #
      # @return [::Numeric]
      attr_reader :id

      # Initializes the reference with the given ID.
      #
      # @param id [::Numeric] The ID.
      def initialize(id)
        @id = id
      end

      def as(type)
        Tacky::Typed.new(self, type)
      end
    end
  end
end
